Index: trunk/SophyaPI/PI/pigraphx.cc
===================================================================
--- trunk/SophyaPI/PI/pigraphx.cc	(revision 157)
+++ trunk/SophyaPI/PI/pigraphx.cc	(revision 158)
@@ -14,8 +14,9 @@
 #define NMAXFONTSZ  7
 static XFontStruct * fntst[NMAXFONTSZ][3];
-static int fntsz[NMAXFONTSZ] = {8,10,12,14,16,20,24};
+static int fntsz[NMAXFONTSZ] = {8,10,12,14,18,24,36};
 static int SmallFontIndex = 1; 
 static int NormalFontIndex = 3;
-static int BigFontIndex = 6;
+static int BigFontIndex = 5;
+static int HugeFontIndex = 6;
 static  PIFontAtt fntatt[3] = { PI_RomanFont, PI_BoldFont, PI_ItalicFont }; 
 #define NMAXCOL  16
@@ -31,7 +32,15 @@
 : PIGraphicGen(wdg)
 {
+
 Init();
 
+if (MyWdg()) {
+  mDisp = XtDisplay(MyWdg());       // Structure Display X associe
+  mWId = XtWindow(MyWdg());   // Le drawable X
+  }
+else mDisp = PIXDisplay();       // Structure Display X associe
+
 mDefGC = XCreateGC (PIXDisplay(), XtWindow(PIXtTopWdg()), 0, NULL);
+
 mGOm = PI_GOCopy;
 
@@ -53,14 +62,22 @@
 
 /* --Methode-- */
+void PIGraphicX::TerminateInit()
+{
+if (MyWdg() == NULL)  { fprintf(stderr, "BUG/PIGraphicX::TerminateInit() for NULL Wdg \n"); return; }
+mDisp = XtDisplay(MyWdg());       // Structure Display X associe
+mWId = XtWindow(MyWdg());   // Le drawable X
+}
+
+/* --Methode-- */
 void PIGraphicX::Erase(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy)
 {
-XClearArea (XtDisplay(MyWdg()),XtWindow(MyWdg()), (int)x0, (int)y0, (int)dx, (int)dy, False );
-return;
-}
-
-/* --Methode-- */
-void PIGraphicX::DrawString(PIGrCoord x, PIGrCoord y, char* s, int /*pos*/)
-{
-XDrawString (XtDisplay (MyWdg()),XtWindow(MyWdg()), 
+XClearArea (mDisp,mWId, (int)x0, (int)y0, (int)dx, (int)dy, False );
+return;
+}
+
+/* --Methode-- */
+void PIGraphicX::DrawString(PIGrCoord x, PIGrCoord y, const char* s, int /*pos*/)
+{
+XDrawString (XtDisplay (MyWdg()),mWId, 
                   DefGC(), (int)x, (int)y, s, strlen(s));
 return;
@@ -68,7 +85,7 @@
 
 /* --Methode-- */
-void PIGraphicX::DrawOpaqueString(PIGrCoord x, PIGrCoord y, char* s, int /*pos*/)
-{
-XDrawImageString (XtDisplay (MyWdg()),XtWindow(MyWdg()), 
+void PIGraphicX::DrawOpaqueString(PIGrCoord x, PIGrCoord y, const char* s, int /*pos*/)
+{
+XDrawImageString (XtDisplay (MyWdg()),mWId, 
                   DefGC(), (int)x, (int)y, s, strlen(s));
 return;
@@ -79,5 +96,5 @@
 void PIGraphicX::DrawLine(PIGrCoord x1, PIGrCoord y1, PIGrCoord x2, PIGrCoord y2)
 {
-XDrawLine(XtDisplay (MyWdg()), XtWindow(MyWdg()), DefGC(), (int)x1, (int)y1, (int)x2, (int)y2);
+XDrawLine(XtDisplay (MyWdg()), mWId, DefGC(), (int)x1, (int)y1, (int)x2, (int)y2);
 return;
 }
@@ -93,5 +110,5 @@
 if (idx < 0)  { ix0 += idx;  idx = -idx; }
 if (idy < 0)  { iy0 += idy;  idy = -idy; }
-XDrawRectangle(XtDisplay (MyWdg()), XtWindow(MyWdg()), 
+XDrawRectangle(XtDisplay (MyWdg()), mWId, 
                DefGC(), ix0, iy0, idx, idy);
 return;
@@ -107,5 +124,5 @@
 if (idx < 0)  { ix0 += idx;  idx = -idx; }
 if (idy < 0)  { iy0 += idy;  idy = -idy; }
-XFillRectangle(XtDisplay (MyWdg()), XtWindow(MyWdg()), 
+XFillRectangle(XtDisplay (MyWdg()), mWId, 
                DefGC(), ix0, iy0, idx, idy);
 return;
@@ -115,5 +132,5 @@
 void PIGraphicX::DrawCircle(PIGrCoord x0, PIGrCoord y0, PIGrCoord r)
 {
-XDrawArc(XtDisplay (MyWdg()), XtWindow(MyWdg()), DefGC(),
+XDrawArc(XtDisplay (MyWdg()), mWId, DefGC(),
          (int)x0-(int)r, (int)y0-(int)r, 2*(int)r, 2*(int)r, 0, 360*64);
 return;
@@ -123,6 +140,22 @@
 void PIGraphicX::DrawFCircle(PIGrCoord x0, PIGrCoord y0, PIGrCoord r)
 {
-XFillArc(XtDisplay (MyWdg()), XtWindow(MyWdg()), DefGC(),
+XFillArc(XtDisplay (MyWdg()), mWId, DefGC(),
          (int)x0-(int)r, (int)y0-(int)r, 2*(int)r, 2*(int)r, 0, 360*64);
+return;
+}
+
+/* --Methode-- */
+void PIGraphicX::DrawOval(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy)
+{
+XDrawArc(XtDisplay (MyWdg()), mWId, DefGC(),
+         (int)x0, (int)y0, (int)dx, (int)dy, 0, 360*64);
+return;
+}
+
+/* --Methode-- */
+void PIGraphicX::DrawFOval(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy)
+{
+XFillArc(XtDisplay (MyWdg()), mWId, DefGC(),
+         (int)x0, (int)y0, (int)dx, (int)dy, 0, 360*64);
 return;
 }
@@ -144,5 +177,5 @@
 int mode = CoordModeOrigin;
 if (cinc) mode =  CoordModePrevious;
-XDrawLines(XtDisplay(MyWdg()), XtWindow(MyWdg()), DefGC(), pxp, n, mode);
+XDrawLines(mDisp, mWId, DefGC(), pxp, n, mode);
 if (n > NMXXPOINTS)  delete[] pxp;
 
@@ -164,8 +197,26 @@
 int mode = CoordModeOrigin;
 if (cinc) mode =  CoordModePrevious;
-XFillPolygon(XtDisplay (MyWdg()), XtWindow(MyWdg()), DefGC(), pxp, n, 
+XFillPolygon(XtDisplay (MyWdg()), mWId, DefGC(), pxp, n, 
                         Complex, mode);
 if (n > NMXXPOINTS)  delete[] pxp;
 
+return;
+}
+
+/* --Methode-- */
+void PIGraphicX::DrawArc(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy, 
+                         float degdeb, float degfin)
+{
+XDrawArc(XtDisplay (MyWdg()), mWId, DefGC(),
+         (int)x0, (int)y0, (int)dx, (int)dy, (int)(degdeb*64.), (int)(degfin*64.));
+return;
+}
+
+/* --Methode-- */
+void PIGraphicX::DrawFArc(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy, 
+                         float degdeb, float degfin)
+{
+XFillArc(XtDisplay (MyWdg()), mWId, DefGC(),
+         (int)x0, (int)y0, (int)dx, (int)dy, (int)(degdeb*64.), (int)(degfin*64.));
 return;
 }
@@ -180,5 +231,5 @@
 
 if (mMrk == PI_DotMarker)
-  XDrawPoint(XtDisplay(MyWdg()), XtWindow(MyWdg()), DefGC(), (int)x0, (int)y0);
+  XDrawPoint(mDisp, mWId, DefGC(), (int)x0, (int)y0);
 
 else  {
@@ -217,5 +268,5 @@
       break;
     default :
-      XDrawPoint(XtDisplay(MyWdg()), XtWindow(MyWdg()), DefGC(), x0, y0);
+      XDrawPoint(mDisp, mWId, DefGC(), x0, y0);
       break;
     }
@@ -238,5 +289,5 @@
   else pxp = multipoint;
   for(i=0; i<n; i++)  { pxp[i].x = x[i];  pxp[i].y = y[i]; } 
-  XDrawPoints(XtDisplay(MyWdg()), XtWindow(MyWdg()), DefGC(), pxp, n, CoordModeOrigin);
+  XDrawPoints(mDisp, mWId, DefGC(), pxp, n, CoordModeOrigin);
   if (n > NMXXPOINTS)  delete[] pxp;  
   }
@@ -263,5 +314,5 @@
 
   
-xw = XtWindow(MyWdg());
+xw = mWId;
 mdsp = PIXDisplay();
 scr = PIXScreen();
@@ -294,5 +345,5 @@
 if (col == mFCol)  return;
 if ( (col < 0) || (col >= NMAXCOL))  return;
-XSetForeground(XtDisplay(MyWdg()), DefGC(), colpix[col]); 
+XSetForeground(mDisp, DefGC(), colpix[col]); 
 mFCol = col;  
 return;
@@ -304,5 +355,5 @@
 if (col == mBCol)  return;
 if ( (col < 0) || (col >= NMAXCOL))  return;
-XSetBackground(XtDisplay(MyWdg()), DefGC(), colpix[col]); 
+XSetBackground(mDisp, DefGC(), colpix[col]); 
 mBCol = col;  
 return;
@@ -328,9 +379,9 @@
   {
   case PI_GOCopy :
-    XSetFunction(XtDisplay(MyWdg()), DefGC(), GXcopy);
+    XSetFunction(mDisp, DefGC(), GXcopy);
     mGOm = mod;
     break;
   case PI_GOXOR :
-    XSetFunction(XtDisplay(MyWdg()), DefGC(), GXxor);
+    XSetFunction(mDisp, DefGC(), GXxor);
     mGOm = mod;
     break;
@@ -377,4 +428,7 @@
     i = BigFontIndex;
     break;
+  case PI_HugeSizeFont:
+    i = HugeFontIndex;
+    break;
   default:
     i = NormalFontIndex;
@@ -432,6 +486,9 @@
     break;
   }
-    
-XSetLineAttributes(XtDisplay(MyWdg()), DefGC(), lt, lstyle, CapButt, JoinMiter);
+if (lstyle != LineSolid) { 
+  char dash[2]= {3,3};   
+  XSetDashes( mDisp, DefGC(), 0, dash, 2);
+  }
+XSetLineAttributes(mDisp, DefGC(), lt, lstyle, CapButt, JoinMiter);
 mLAtt = att;
 return;
@@ -454,6 +511,6 @@
 xr.x = x0;  xr.y = y0;
 xr.width = dx;  xr.height = dy;
-XSetClipRectangles(XtDisplay(MyWdg()), DefGC(), 0, 0, &xr, 1, Unsorted);
-XSetClipRectangles(XtDisplay(MyWdg()), dpxgc, 0, 0, &xr, 1, Unsorted);
+XSetClipRectangles(mDisp, DefGC(), 0, 0, &xr, 1, Unsorted);
+XSetClipRectangles(mDisp, dpxgc, 0, 0, &xr, 1, Unsorted);
 return;
 }
@@ -462,6 +519,6 @@
 void PIGraphicX::ClearClipRectangle()
 { 
-XSetClipMask(XtDisplay(MyWdg()), DefGC(), None);
-XSetClipMask(XtDisplay(MyWdg()), dpxgc, None);
+XSetClipMask(mDisp, DefGC(), None);
+XSetClipMask(mDisp, dpxgc, None);
 return;
 }
@@ -673,7 +730,10 @@
   if (kkj < kkdsz)  {  kksel = kkk;  kkdsz = kkj; }
   }
+if (kksel == NMAXFONTSZ-1)  kksel = NMAXFONTSZ-2;
 NormalFontIndex = kksel;
 SmallFontIndex = (kksel > 1) ? kksel-2 : 0 ;
-BigFontIndex = (kksel < NMAXFONTSZ-3) ? kksel+3 : NMAXFONTSZ-1 ;
+BigFontIndex =  NMAXFONTSZ-2 ;
+if (BigFontIndex < NormalFontIndex)  BigFontIndex = NormalFontIndex;
+HugeFontIndex = NMAXFONTSZ-1;
 
 //printf("PIGraphicX::Init()-DBG- FontIndex= %d %d %d (%d) \n", 
@@ -754,7 +814,7 @@
 mFSize = fntsz[isz];
 mFSt = fntst[isz][jat];
-XSetFont(XtDisplay(MyWdg()), DefGC(), fntst[isz][jat]->fid);
-return;
-}
-
-
+XSetFont(mDisp, DefGC(), fntst[isz][jat]->fid);
+return;
+}
+
+
Index: trunk/SophyaPI/PI/pigraphx.h
===================================================================
--- trunk/SophyaPI/PI/pigraphx.h	(revision 157)
+++ trunk/SophyaPI/PI/pigraphx.h	(revision 158)
@@ -1,2 +1,3 @@
+// This may look like C code, but it is really -*- C++ -*-
 // Module PI : Peida Interactive     PIGraphicX
 // Trace graphiques- Implementation X11  R. Ansari  97
@@ -17,6 +18,6 @@
 //  Trace graphiques
   virtual void       Erase(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy);
-  virtual void       DrawString(PIGrCoord x, PIGrCoord y, char* s, int pos = 0);
-  virtual void       DrawOpaqueString(PIGrCoord x, PIGrCoord y, char* s, int pos = 0);
+  virtual void       DrawString(PIGrCoord x, PIGrCoord y, const char* s, int pos = 0);
+  virtual void       DrawOpaqueString(PIGrCoord x, PIGrCoord y, const char* s, int pos = 0);
   virtual void       DrawLine(PIGrCoord x1, PIGrCoord y1, PIGrCoord x2, PIGrCoord y2);
   virtual void       DrawBox(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy);
@@ -24,6 +25,12 @@
   virtual void       DrawCircle(PIGrCoord x0, PIGrCoord y0, PIGrCoord r);
   virtual void       DrawFCircle(PIGrCoord x0, PIGrCoord y0, PIGrCoord r);
+  virtual void       DrawOval(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy);
+  virtual void       DrawFOval(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy);
   virtual void       DrawPolygon(PIGrCoord *x, PIGrCoord *y, int n, bool cinc=true);  
   virtual void       DrawFPolygon(PIGrCoord *x, PIGrCoord *y, int n, bool cinc=true);  
+  virtual void       DrawArc(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy,
+                             float degdeb, float degfin);
+  virtual void       DrawFArc(PIGrCoord x0, PIGrCoord y0, PIGrCoord dx, PIGrCoord dy, 
+                              float degdeb, float degfin);
   virtual void       DrawMarker(PIGrCoord x0, PIGrCoord y0);
   virtual void       DrawMarkers(PIGrCoord *x, PIGrCoord *y, int n);
@@ -66,4 +73,7 @@
 //  Pour recuperer le pixcol d une couleur  (pour X) 
   PIXColor           GetPixelValueforColor(PIColors col);
+//  Pour initialiser mWId apres creation de fenetre
+  virtual void	     TerminateInit();
+
 protected:
   void           Init();
@@ -72,10 +82,13 @@
   inline SysDWdg MyWdg()  {return(myWdg->XtWdg()); }
   inline void    SelectBCol(PIXColor col) 
-    {XSetBackground(XtDisplay(MyWdg()), DefGC(), col);  mBCol = PI_ColorFromMap; mBCfMap = col; }
+    {XSetBackground(mDisp, DefGC(), col);  mBCol = PI_ColorFromMap; mBCfMap = col; }
   inline void    SelectFCol(PIXColor col) 
-    {XSetForeground(XtDisplay(MyWdg()), DefGC(), col);  mFCol = PI_ColorFromMap; mFCfMap = col; }
+    {XSetForeground(mDisp, DefGC(), col);  mFCol = PI_ColorFromMap; mFCfMap = col; }
 
+//  Structure et identificateur XWindow  associe
+  GC mDefGC;
+  Display* mDisp;  // Display X associe
+  Drawable mWId;   // Identificateur Window/Drawable X
 
-  GC mDefGC;
   PIColors  mFCol, mBCol;
   PIGOMode mGOm;
Index: trunk/SophyaPI/PI/piscdrawwdg.cc
===================================================================
--- trunk/SophyaPI/PI/piscdrawwdg.cc	(revision 157)
+++ trunk/SophyaPI/PI/piscdrawwdg.cc	(revision 158)
@@ -17,4 +17,5 @@
   xEndDrag = yEndDrag = xBegDrag = yBegDrag = 0;
   SetDefaultDrawRectangle(0.12, 0.12, 0.88, 0.88, true);
+//  SetDefaultDrawRectangle(0.12, 0.08, 0.88, 0.92, true);
   AddDrawer(mBDrw, true, false, false);
   
Index: trunk/SophyaPI/PI/piscdrawwdg.h
===================================================================
--- trunk/SophyaPI/PI/piscdrawwdg.h	(revision 157)
+++ trunk/SophyaPI/PI/piscdrawwdg.h	(revision 158)
@@ -31,4 +31,9 @@
 
   inline void        SetAxesFlags(unsigned int flags=kAxesDflt) { mBDrw->SetAxesFlags(flags); }
+
+  inline void	     SetTitles(const char* tt=NULL, const char* tb=NULL)
+                            { mBDrw->SetTitles(tt, tb); }
+  inline void	     SetTitles(string const & tt, string const & tb)
+                            { mBDrw->SetTitles(tt, tb); }
 
   int                AddScDrawer(PIDrawer*, bool ad=false);   // Ajoute un Drawer en auto 
@@ -76,5 +81,4 @@
   PIWindow * mTrW;
 
-
 private:
   bool  UpdateText(int xp, int yp);
Index: trunk/SophyaPI/PI/pistzwin.cc
===================================================================
--- trunk/SophyaPI/PI/pistzwin.cc	(revision 157)
+++ trunk/SophyaPI/PI/pistzwin.cc	(revision 158)
@@ -1,4 +1,5 @@
 // This may look like C code, but it is really -*- C++ -*-
-// Module PI : Peida Interactive  PIStackWindow  PIZoneWindow
+// Module PI : Peida Interactive  - Zone/Stack Layout
+// PIStackLayout , PIZone Layout , PIStackWindow , PIZoneWindow
 //                             R. Ansari  08/98
 
@@ -8,34 +9,24 @@
 #include "psfile.h"
 
-// Fonction de l'objet PIPeriodic de PIStackWindow
-static void myadperpact(void* a);
-
-void myadperpact(void* a)
-{
-((PIStackWindow*)a)->DispNext();
-}
-/* --Methode-- */
-PIStackWindow::PIStackWindow(PIMsgHandler* par, char* nom, PIWindowKind k,
-                             int sx, int sy, int px, int py)
-        : PIWindow(par, nom, k, sx, sy, px, py) , mPerad(1)
+// -------------- Classe PIStackLayout --------------
+
+/* --Methode-- */
+PIStackLayout::PIStackLayout()
+	: PILayoutMgr()
 {
 mCurdisp = -1;
-mPerad.SetAction(myadperpact, this);
-} 
-
-
-/* --Methode-- */
-PIStackWindow::~PIStackWindow()
-{
-mPerad.Stop();
-Hide();
-}
-
-/* --Methode-- */
-void PIStackWindow::ChildAdd(PIWdg* child)
+}
+
+/* --Methode-- */
+PIStackLayout::~PIStackLayout()
+{
+}
+
+/* --Methode-- */
+void PIStackLayout::ChildAdd(PIWdg* child)
 {
 int k;
 for(k=0; k<NbChilds(); k++) GetChild(k)->UnManage();
-PIWindow::ChildAdd(child);
+PILayoutMgr::ChildAdd(child);
 child->Manage();
 mCurdisp = NbChilds()-1;
@@ -44,9 +35,9 @@
 
 /* --Methode-- */
-void PIStackWindow::ChildDel(PIWdg* child)
+void PIStackLayout::ChildDel(PIWdg* child)
 {
 int k;
 for(k=0; k<NbChilds(); k++) GetChild(k)->UnManage();
-PIWindow::ChildDel(child);
+PILayoutMgr::ChildDel(child);
 if (NbChilds() > 0) {
   mCurdisp--;
@@ -60,4 +51,59 @@
 
 /* --Methode-- */
+void PIStackLayout::DispNext()
+{
+if (NbChilds() < 1) return;
+int n = (mCurdisp+1)%NbChilds();
+DispWdgNum(n);
+}
+
+/* --Methode-- */
+void PIStackLayout::DispWdgNum(int n)
+{
+if ( (n < 0) || (n >= NbChilds()) )  return;
+for(int k=0; k<NbChilds(); k++) GetChild(k)->UnManage();
+mCurdisp = n;
+GetChild(mCurdisp)->Manage();
+return;
+}
+
+
+// -------------- Classe PIStackWindow --------------
+
+// Fonction de l'objet PIPeriodic de PIStackWindow
+static void myadperpact(void* a);
+
+void myadperpact(void* a)
+{
+((PIStackWindow*)a)->DispNext();
+}
+
+/* --Methode-- */
+PIStackWindow::PIStackWindow(PIMsgHandler* par, char* nom, PIWindowKind k,
+                             int sx, int sy, int px, int py)
+        : PIWindow(par, nom, k, sx, sy, px, py) , mPerad(1)
+{
+mPerad.SetAction(myadperpact, this);
+delete layout;
+layout = new PIStackLayout;
+layout->SetContainer(this); 
+} 
+
+
+/* --Methode-- */
+PIStackWindow::~PIStackWindow()
+{
+mPerad.Stop();
+Hide();
+}
+
+/* --Methode-- */
+void PIStackWindow::SetLayoutMgr(PILayoutMgr*)
+{
+fprintf(stderr, "PIStackWindow::SetLayoutMgr() - LayoutMgr cannot be changed \n");
+return;
+}
+
+/* --Methode-- */
 void PIStackWindow::PSPrint(PSFile *psf, int ofx, int ofy)
 {
@@ -70,22 +116,4 @@
 }
 
-/* --Methode-- */
-PIWdg* PIStackWindow::CurrentWdg()
-{
-return(GetChild(mCurdisp));
-}
-
-/* --Methode-- */
-void PIStackWindow::DispNext()
-{
-if (NbChilds() < 1) return;
-mCurdisp = (mCurdisp+1)%NbChilds();
-PIWdg* wc = GetChild(mCurdisp);
-wc->Manage();
-int k;
-for(k=0; k<NbChilds(); k++) 
-  if (k != mCurdisp) GetChild(k)->UnManage();
-return;
-}
 
 /* --Methode-- */
@@ -101,10 +129,9 @@
 }
 
-//-------------------------------------------------------------------------------
-
-/* --Methode-- */
-PIZoneWindow::PIZoneWindow(PIMsgHandler* par, char* nom, PIWindowKind k,
-                           int nzx, int nzy, int sx, int sy, int px, int py)
-        : PIWindow(par, nom, k, sx, sy, px, py)
+//-------------------- Classe PIZoneLayout ------------------------------
+
+/* --Methode-- */
+PIZoneLayout::PIZoneLayout(int nzx, int nzy)
+	: PILayoutMgr()
 {
 mZWdg = NULL;
@@ -113,11 +140,12 @@
 
 /* --Methode-- */
-PIZoneWindow::~PIZoneWindow()
+PIZoneLayout::~PIZoneLayout()
 {
 delete[] mZWdg;
 }
 
-/* --Methode-- */
-void PIZoneWindow::SetZone(int nzx, int nzy)
+
+/* --Methode-- */
+void PIZoneLayout::SetZone(int nzx, int nzy)
 {
 int i;
@@ -140,13 +168,13 @@
 
 /* --Methode-- */
-void PIZoneWindow::ChildAdd(PIWdg * child)
+void PIZoneLayout::ChildAdd(PIWdg * child)
 {
 if (!child) return;
 int nx = mZc%mZx;
 int ny = mZc/mZx;
-PIWindow::ChildAdd(child);
+PILayoutMgr::ChildAdd(child);
 child->SetBinding(PIBK_free,PIBK_free,PIBK_free, PIBK_free);
-int sx = XSize()/mZx;
-int sy = YSize()/mZy;
+int sx = mCont->XSize()/mZx;
+int sy = mCont->YSize()/mZy;
 child->SetPos(nx*sx, ny*sy);
 child->SetSize(sx, sy);
@@ -162,5 +190,5 @@
 
 /* --Methode-- */
-void PIZoneWindow::ChildDel(PIWdg * child)
+void PIZoneLayout::ChildDel(PIWdg * child)
 {
 if (!child)  return;
@@ -168,10 +196,10 @@
 for(k=0; k<mZx*mZy; k++) 
   if (mZWdg[k] == child) mZWdg[k] = NULL;  
-PIWindow::ChildDel(child);
-return;
-}
-
-/* --Methode-- */
-void PIZoneWindow::NbZone(int& nzx, int& nzy)
+PILayoutMgr::ChildDel(child);
+return;
+}
+
+/* --Methode-- */
+void PIZoneLayout::NbZone(int& nzx, int& nzy)
 {
 nzx = mZx;   nzy = mZy;
@@ -179,8 +207,8 @@
 
 /* --Methode-- */
-PIWdg* PIZoneWindow::NextChildPosSize(int& px, int& py, int& sx, int& sy)
-{
-sx = XSize()/mZx;
-sy = YSize()/mZy;
+PIWdg* PIZoneLayout::NextChildPosSize(int& px, int& py, int& sx, int& sy)
+{
+sx = mCont->XSize()/mZx;
+sy = mCont->YSize()/mZy;
 int nx = mZc%mZx;
 int ny = mZc/mZx;
@@ -188,2 +216,29 @@
 return ((PIWdg*)mZWdg[mZc]);
 }
+
+
+//-------------------- Classe PIZoneWindow ------------------------------
+
+/* --Methode-- */
+PIZoneWindow::PIZoneWindow(PIMsgHandler* par, char* nom, PIWindowKind k,
+                           int nzx, int nzy, int sx, int sy, int px, int py)
+        : PIWindow(par, nom, k, sx, sy, px, py)
+{
+delete layout;
+layout = new PIZoneLayout(nzx, nzy);
+layout->SetContainer(this); 
+}
+
+/* --Methode-- */
+PIZoneWindow::~PIZoneWindow()
+{
+Hide();
+}
+
+/* --Methode-- */
+void PIZoneWindow::SetLayoutMgr(PILayoutMgr*)
+{
+fprintf(stderr, "PIZoneWindow::SetLayoutMgr() - LayoutMgr cannot be changed \n");
+return;
+}
+
Index: trunk/SophyaPI/PI/pistzwin.h
===================================================================
--- trunk/SophyaPI/PI/pistzwin.h	(revision 157)
+++ trunk/SophyaPI/PI/pistzwin.h	(revision 158)
@@ -10,7 +10,27 @@
 #include PIPERIODIC_H
 
+// ----------------------- Classe PIStackLayout ----------------------------
+// Pour Fenetre de type empilement , tout widget occupe la totalite 
+// de la fenetre - Un seul des widget visible (active) a chaque moment
+
+class PIStackLayout : public PILayoutMgr {
+public:
+		PIStackLayout();
+  virtual 	~PIStackLayout();
+
+  virtual void  ChildAdd(PIWdg* child);
+  virtual void  ChildDel(PIWdg* child);
+
+  inline PIWdg*  CurrentWdg() { return(GetChild(mCurdisp)); }
+  inline int    NumCurrentWdg() { return(mCurdisp); } 
+  virtual void  DispNext();
+  virtual void  DispWdgNum(int n);
+
+protected:
+  int mCurdisp;
+};
+		
 // ----------------------- Classe PIStackWindow ----------------------------
-// Fenetre de type empilement , tout widget occupe la totalite de la fenetre,
-// Un seul des widget visible (active) a chaque moment
+//                    Fenetre avec un PIStackLayout
 
 class PIStackWindow : public PIWindow {
@@ -18,13 +38,12 @@
 		PIStackWindow(PIMsgHandler* par, char* nom, PIWindowKind k=PIWK_normal,
                               int sx=100, int sy=100, int px=0, int py=0);
-		~PIStackWindow();
+  virtual	~PIStackWindow();
 
-  virtual void  ChildAdd(PIWdg* child);
-  virtual void  ChildDel(PIWdg* child);
-
+  virtual void  SetLayoutMgr(PILayoutMgr* nlay);
   virtual void  PSPrint(PSFile *psf, int ofx=0, int ofy=0);
 
-  virtual PIWdg*  CurrentWdg();
-  virtual void  DispNext();
+  inline  void  DispNext() { ((PIStackLayout*)layout)->DispNext(); }
+  inline  PIWdg* CurrentWdg() { return( ((PIStackLayout*)layout)->CurrentWdg() ); }
+
   virtual void  StartAutoDisp(int dt);
   virtual void  StopAutoDisp();
@@ -32,10 +51,29 @@
 protected:
   PIPeriodic mPerad;
-  int mCurdisp;
+};
+
+// ----------------------- Classe PIZoneLayout ----------------------------
+// Pour fenetre avec nzx*nzy zone d affichage - Les nouveaux widgets dans chaque
+// zone viennent remplacer les anciennes - Ceux-ci sont detruits automatiquement
+
+
+class PIZoneLayout : public PILayoutMgr {
+public:
+		PIZoneLayout(int nzx=1, int nzy=1);
+  virtual 	~PIZoneLayout();
+
+  virtual void  ChildAdd(PIWdg* child);
+  virtual void  ChildDel(PIWdg* child);
+  virtual void  SetZone(int nzx, int nzy);
+  virtual void  NbZone(int& nzx, int& nzy);
+  virtual PIWdg* NextChildPosSize(int& px, int& py, int& sx, int& sy);
+
+protected:
+  int mZx, mZy, mZc;
+  PIWdg** mZWdg;
 };
 
 // ----------------------- Classe PIZoneWindow ----------------------------
-// Fenetre avec nzx*nzy zone d affichage - Les nouveaux widgets dans chaque
-// zone viennent remplacer les anciennes - Ceux-ci sont detruits automatiquement
+//                    Fenetre avec un PIZoneLayout 
  
 class PIZoneWindow : public PIWindow {
@@ -43,15 +81,15 @@
 		PIZoneWindow(PIMsgHandler* par, char* nom, PIWindowKind k=PIWK_normal,
                              int nzx=1, int nzy=1, int sx=100, int sy=100, int px=0, int py=0);
-		~PIZoneWindow();
+  virtual	~PIZoneWindow();
 
-  virtual void  ChildAdd(PIWdg* child);
-  virtual void  ChildDel(PIWdg* child);
-  virtual void  SetZone(int nzx, int nzy);
-  virtual void  NbZone(int& nzx, int& nzy);
-  virtual PIWdg*  NextChildPosSize(int& px, int& py, int& sx, int& sy);
+  virtual void  SetLayoutMgr(PILayoutMgr* nlay);
+
+  inline  void  SetZone(int nzx, int nzy) { ((PIZoneLayout*)layout)->SetZone(nzx, nzy); }
+  inline  void  NbZone(int& nzx, int& nzy)  { ((PIZoneLayout*)layout)->NbZone(nzx, nzy); }
+  inline PIWdg* NextChildPosSize(int& px, int& py, int& sx, int& sy)
+                { return ( ((PIZoneLayout*)layout)->NextChildPosSize(px, py, sx, sy) ); }
 
 protected:
-  int mZx, mZy, mZc;
-  PIWdg** mZWdg;
 };
+
 #endif
Index: trunk/SophyaPI/PI/piwdggen.h
===================================================================
--- trunk/SophyaPI/PI/piwdggen.h	(revision 157)
+++ trunk/SophyaPI/PI/piwdggen.h	(revision 158)
@@ -1,5 +1,6 @@
 // This may look like C code, but it is really -*- C++ -*-
-// Module PI : Peida Interactive      PIWindowGen
+// Module PI : Peida Interactive      PIWdgGen
 //                                    Reza 10/95            
+// LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
 
 #ifndef PIWDG_H_SEEN
Index: trunk/SophyaPI/PI/piwdgx.h
===================================================================
--- trunk/SophyaPI/PI/piwdgx.h	(revision 157)
+++ trunk/SophyaPI/PI/piwdgx.h	(revision 158)
@@ -90,4 +90,5 @@
 unsigned long PIXGetLastEventSerial();
 void PIXSetLastEventTimeSerial(Time t, unsigned long ser);
+void PIXGetLastEventInfo(unsigned int& st, Time& t);
 
 
Index: trunk/SophyaPI/PI/pixtbase.cc
===================================================================
--- trunk/SophyaPI/PI/pixtbase.cc	(revision 157)
+++ trunk/SophyaPI/PI/pixtbase.cc	(revision 158)
@@ -97,7 +97,9 @@
 
 
-/*  Last XEvent Serial Number and Time-Stamp  */
+/*  Last XEvent Serial Number and Time-Stamp , and Key-state */
 static Time last_time_xevt = 0;
 static unsigned long last_serial_xevt = 0;
+static unsigned int  last_state_xevt = 0;
+
 
 Time PIXGetLastEventTime() { return(last_time_xevt); }
@@ -105,4 +107,6 @@
 void PIXSetLastEventTimeSerial(Time t, unsigned long ser) 
 { last_time_xevt = t;  last_serial_xevt = ser; }
+void PIXGetLastEventInfo(unsigned int& st, Time& t)
+{ st = last_state_xevt;  t = last_time_xevt; }
 
 /* Nouvelle-Fonction */
@@ -203,4 +207,5 @@
     last_time_xevt = evt->xcrossing.time;
     last_serial_xevt = evt->xcrossing.serial;
+    last_state_xevt = evt->xcrossing.state;
 //    if (((PIXtBaseWidget)wdgp)->pixtbase.objet) 
     (((PIXtBaseWidget)wdgp)->pixtbase.objet)->Enter();
@@ -214,4 +219,5 @@
     last_time_xevt = evt->xcrossing.time;
     last_serial_xevt = evt->xcrossing.serial;
+    last_state_xevt = evt->xcrossing.state;
 //    if (((PIXtBaseWidget)wdgp)->pixtbase.objet) 
        (((PIXtBaseWidget)wdgp)->pixtbase.objet)->Leave();
@@ -221,4 +227,5 @@
     last_time_xevt = evt->xbutton.time;
     last_serial_xevt = evt->xbutton.serial;
+    last_state_xevt = evt->xbutton.state;
     if ( (evt->xbutton.button == 1) && ( ((PIXtBaseWidget)wdgp)->pixtbase.myeventmask & Button1Mask) )
       (((PIXtBaseWidget)wdgp)->pixtbase.objet)->But1Press(evt->xbutton.x, evt->xbutton.y);
@@ -232,4 +239,5 @@
     last_time_xevt = evt->xbutton.time;
     last_serial_xevt = evt->xbutton.serial;
+    last_state_xevt = evt->xbutton.state;
     if ( (evt->xbutton.button == 1) && ( ((PIXtBaseWidget)wdgp)->pixtbase.myeventmask & Button1Mask) )
       (((PIXtBaseWidget)wdgp)->pixtbase.objet)->But1Release(evt->xbutton.x, evt->xbutton.y);
@@ -250,7 +258,8 @@
       }
     else { key_but =  evt->xmotion.state ; xw = evt->xmotion.x;  yw = evt->xmotion.y; }
-    if  ( !(key_but & ( Button1Mask | Button2Mask | Button3Mask ) ) ) break;
+//    if  ( !(key_but & ( Button1Mask | Button2Mask | Button3Mask ) ) ) break;
       last_time_xevt = evt->xmotion.time;
       last_serial_xevt = evt->xmotion.serial;
+      last_state_xevt = evt->xmotion.state;
       if  (key_but & Button1Mask ) 
         (((PIXtBaseWidget)wdgp)->pixtbase.objet)->Ptr1Move(xw, yw);
@@ -259,4 +268,6 @@
       else  if (key_but & Button3Mask ) 
         (((PIXtBaseWidget)wdgp)->pixtbase.objet)->Ptr3Move(xw, yw);
+      else if ( !(key_but & (Button4Mask|Button5Mask)) ) 
+        (((PIXtBaseWidget)wdgp)->pixtbase.objet)->PtrMove(xw, yw);
     }
   break;
Index: trunk/SophyaPI/PI/psfile.cc
===================================================================
--- trunk/SophyaPI/PI/psfile.cc	(revision 157)
+++ trunk/SophyaPI/PI/psfile.cc	(revision 158)
@@ -14,4 +14,19 @@
 
 #include "psfile.h"
+
+//++
+// Class	PSFile
+// Lib		PI
+// include	psfile.h
+//
+//   	Classe encapsulant un fichier PostScript, fournissant des primitives
+//	graphiques produisant du code PostScript.
+//--
+//++
+// Links	Voir aussi
+// PIGraphicPS
+//--
+
+
 
 /* En cm */
@@ -259,4 +274,15 @@
 "
 
+//++
+// Titre	Constructeurs
+//--
+//++
+// PSFile (const char * FileName, float sc = 1.0)
+//	Créateur pour fichier Encapsulated Postscript
+// PSFile (const char * FileName, PIOrientation orientation, -
+//         PIPaperSize paperSize= PI_A4, -
+//         float marginX = 5.0, float marginY = 5.0 )
+//	Créateur pour fichier Postscript
+//--
 
 /* 
@@ -671,5 +697,5 @@
 
 
-void  PSFile::DrawString  (float x,  float y, char *s, 
+void  PSFile::DrawString  (float x,  float y, const char *s, 
 			   PIColors DrawColor, 
 			   PIFontAtt FontAtt, 
Index: trunk/SophyaPI/PI/psfile.h
===================================================================
--- trunk/SophyaPI/PI/psfile.h	(revision 157)
+++ trunk/SophyaPI/PI/psfile.h	(revision 158)
@@ -103,5 +103,5 @@
 
     /* Trace */
-    virtual void  DrawString  (float x,  float y, char *s, 
+    virtual void  DrawString  (float x,  float y, const char *s, 
 			       PIColors DrawColor  = PI_NotDefColor, 
 			       PIFontAtt FontAtt   = PI_NotDefFontAtt, 
